## ltrapi 1.31.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)


if(NOT LTR_SDK_SUFFIX)
    include(cmake/ltrnames/ltrnames.cmake)
endif(NOT LTR_SDK_SUFFIX)

project(ltrapi C)

set(LTRAPI_VER_MAJOR 1)
set(LTRAPI_VER_MINOR 31)
set(LTRAPI_VER_PATCH 3)
set(LTRAPI_VERSION   ${LTRAPI_VER_MAJOR}.${LTRAPI_VER_MINOR}.${LTRAPI_VER_PATCH})

option(LTR_FORCE_RESET_WHEN_IN_USE "Send STOP-RESET-STOP if module in use for compatibility with old behavior" OFF)
option(LTR_BUILD_EXAMPLES  "Build ltrapi C examples" OFF)
option(LTR_DEBUG_PRINT "Debug console printf" OFF)
option(LTR_ERROR_PRINT "Debug console printf" OFF)
# linux: с версии 1.31.2 по-умолчанию приход сигнала на Linux не прерывает работу функций
# Recv() и Send(), т.к. в некоторых случаях сигналы могут использоваться переодически
# и нарушать работу функций (например в Mono при нескольких потоках).
# Для использования старого поведения можно включить данную опцию
option(LTRAPI_STOP_ON_SIGNAL "Stop Recv() and Send() on linux signal" OFF)
option(LTRAPI_BUILD_STATIC "Build static libraries rather dynamic" OFF)
option(LTRAPI_BUILD_FABRIC_MODULES "Build library for fabric modules" OFF)
option(LTRAPI_BUILD_DEVELOP_MODULES "Build library for currently development modules" OFF)


if(LTR_PRODUCT_NAMES_FILE)
    include(${LTR_PRODUCT_NAMES_FILE})
endif(LTR_PRODUCT_NAMES_FILE)

if(WIN32)
    option(LTRAPI_BUILD_BORLAND_LIBS "Make .lib files for Borland C++/C++ Builder compiler" OFF)
    option(LTRAPI_BUILD_MINGW_LIBS "Make .a files for mingw compiler" OFF)
endif(WIN32)

if(NOT LTRAPI_PREPARE_HEADERS)
    option(LTRAPI_PREPARE_HEADERS "prepare pucblic ltrapi headers in build directory" OFF)
endif(NOT LTRAPI_PREPARE_HEADERS)

if(LTR_FORCE_RESET_WHEN_IN_USE)
    add_definitions(-DLTR_FORCE_RESET_WHEN_IN_USE)
endif(LTR_FORCE_RESET_WHEN_IN_USE)

if(LTRAPI_STOP_ON_SIGNAL)
    add_definitions(-DLTRAPI_STOP_ON_SIGNAL)
endif(LTRAPI_STOP_ON_SIGNAL)

if(LTR_DEBUG_PRINT)
    add_definitions(-DLTR_DEBUG_PRINT)
endif(LTR_DEBUG_PRINT)

if(LTR_ERROR_PRINT)
    add_definitions(-DLTR_ERROR_PRINT)
endif(LTR_ERROR_PRINT)

# для QNX4 используются всегда статические библиотеки
if(${CMAKE_SYSTEM_NAME} STREQUAL "QNX4")
    set(LTRAPI_BUILD_STATIC ON)
endif()

if(LTR_BUILD_EXAMPLES)
    set(LTRAPI_PREPARE_HEADERS ON)
endif(LTR_BUILD_EXAMPLES)

include(CheckIncludeFiles)
include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckSymbolExists)


if(CMAKE_COMPILER_IS_GNUCC)
    set(WARNOPTS
        -Werror=implicit-int -Werror=implicit-function-declaration -Werror=strict-prototypes -Werror=return-type
        -Wall -Wextra
        -Wformat-security -Winit-self -Wstrict-aliasing -Wfloat-equal
        -Wundef -Wshadow -Wunsafe-loop-optimizations -Wpointer-arith -Wcast-align
        -Wwrite-strings  -Wsign-compare -Waggregate-return -Winline
        -Wno-unused-parameter -Wno-unused-variable -Wno-aggregate-return)
    add_definitions(${WARNOPTS})
endif(CMAKE_COMPILER_IS_GNUCC)

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_WINSOCK_DEPRECATED_NO_WARNINGS)

    #чтобы не зависеть от runtime включаем его внутрь библиотек
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
       if(${flag_var} MATCHES "/MD")
          string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
       endif(${flag_var} MATCHES "/MD")
    endforeach(flag_var)

    #убираем флаг /INCREMENTAL, так как в MSVC с ним могут быть
    #внутренние ошибки линковщика
    foreach(flag_var
            CMAKE_SHARED_LINKER_FLAGS
            CMAKE_SHARED_LINKER_FLAGS_DEBUG
            CMAKE_SHARED_LINKER_FLAGS_RELEASE
            CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL
            CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO
            CMAKE_EXE_LINKER_FLAGS
            CMAKE_EXE_LINKER_FLAGS_DEBUG
            CMAKE_EXE_LINKER_FLAGS_RELEASE
            CMAKE_EXE_LINKER_FLAGS_MINSIZEREL
            CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO)
       if(${flag_var} MATCHES "/INCREMENTAL:YES")
          string(REGEX REPLACE "/INCREMENTAL:YES" "/INCREMENTAL:NO" ${flag_var} "${${flag_var}}")
       endif(${flag_var} MATCHES "/INCREMENTAL:YES")
    endforeach(flag_var)

endif(MSVC)

set(LTRAPI_SOURCE_DIR ${PROJECT_SOURCE_DIR})
set(LTRAPI_BINARY_DIR  ${PROJECT_BINARY_DIR})
set(LTRAPI_INCLUDE_DIR  ${PROJECT_BINARY_DIR}/include)
set(LTRAPI_LIB_DIR ${PROJECT_SOURCE_DIR}/lib)


set(LTRAPI_CMAKE_DIR ${PROJECT_SOURCE_DIR}/cmake)
set(LTRAPI_MODULE_CMAKE_TEMPLATE ${PROJECT_SOURCE_DIR}/cmake/ltrmodule.cmake)

if(UNIX)
    if(NOT LTRAPI_INSTALL_INCLUDE)
        set(LTRAPI_INSTALL_INCLUDE          include/ltr/include)
    endif(NOT LTRAPI_INSTALL_INCLUDE)
    if(${CMAKE_SYSTEM_NAME} STREQUAL "QNX" AND CMAKE_CROSSCOMPILING)
        set(LTRAPI_INSTALL_LIB          /${CMAKE_SYSTEM_PROCESSOR}/${CMAKE_INSTALL_PREFIX}/lib)
        set(LTRAPI_INSTALL_EXAMPLES     /${CMAKE_SYSTEM_PROCESSOR}/${CMAKE_INSTALL_PREFIX}/bin)
    else()
        if(NOT LTRAPI_INSTALL_LIB)
            set(LTRAPI_INSTALL_LIB          lib)
        endif(NOT LTRAPI_INSTALL_LIB)
        set(LTRAPI_INSTALL_EXAMPLES     bin)
    endif()
    if(NOT LTRAPI_INSTALL_DATA)
        set(LTRAPI_INSTALL_DATA             share/ltrapi)
    endif(NOT LTRAPI_INSTALL_DATA)

    if(NOT LTRAPI_INSTALL_PASCAL)
        set(LTRAPI_INSTALL_PASCAL       include/ltr/pascal)
    endif(NOT LTRAPI_INSTALL_PASCAL)
elseif(WIN32)
    set(LTRAPI_INSTALL_INCLUDE      ltr/include)
    set(LTRAPI_INSTALL_LIB          ltr/lib)
    set(LTRAPI_INSTALL_EXAMPLES     ltr/bin/examples)
    set(LTRAPI_INSTALL_DATA         ltr/data)
    set(LTRAPI_INSTALL_PASCAL       ltr/include/pascal2)
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "QNX4")
    set(LTRAPI_INSTALL_INCLUDE      include/ltr/include)    
    set(LTRAPI_INSTALL_LIB          lib)
    set(LTRAPI_INSTALL_EXAMPLES     bin)
    set(LTRAPI_INSTALL_DATA         share/ltrapi)    
endif(UNIX)

set(LTRAPI_CONFIG_FILE ${PROJECT_SOURCE_DIR}/config.h.in)



check_include_files("stdint.h" LTRAPI_HAVE_STDINT_H)
check_include_files("inttypes.h" LTRAPI_HAVE_INTTYPES_H)
if(WIN32)
    set(LTRAPI_HAVE_INT64             YES)
    set(LTRAPI_HAVE_UINT64            YES)
else(WIN32)
    check_type_size(int64_t           INT64)
    check_type_size(uint64_t          UINT64)
    set(LTRAPI_HAVE_INT64             ${HAVE_INT64})
    set(LTRAPI_HAVE_UINT64            ${HAVE_UINT64})
endif(WIN32)

set(CMAKE_EXTRA_INCLUDE_FILES ${CMAKE_EXTRA_INCLUDE_FILES} sys/socket.h time.h)
check_type_size(socklen_t HAVE_SOCKLEN_T)
check_symbol_exists(MSG_NOSIGNAL ${CMAKE_EXTRA_INCLUDE_FILES} HAVE_MSG_NOSIGNAL)
check_function_exists(strnlen HAVE_STRNLEN)
check_include_files("string.h" HAVE_STRING_H)

check_function_exists(usleep LTRAPI_HAVE_USLEEP)

if(${CMAKE_SYSTEM_NAME} STREQUAL "QNX4")
    set(__QNX4__ ON)
    set(LTRAPI_HAVE_NANOSLEEP ON)
else()
    check_function_exists(strlen LTRAPI_HAVE_NANOSLEEP)
endif()

check_include_files("sys/timers.h" HAVE_SYS_TIMERS_H)
if(HAVE_SYS_TIMERS_H)
    check_symbol_exists(CLOCK_MONOTONIC "sys/timers.h" HAVE_CLOCK_MONOTONIC)
endif(HAVE_SYS_TIMERS_H)
if(NOT HAVE_CLOCK_MONOTONIC)
    check_symbol_exists(CLOCK_MONOTONIC "time.h" HAVE_CLOCK_MONOTONIC)
endif(NOT HAVE_CLOCK_MONOTONIC)

configure_file(ltrapi_config.h.in ${LTRAPI_INCLUDE_DIR}/ltrapi_config.h)


#set(CMAKE_VERBOSE_MAKEFILE ON)

add_subdirectory(ltrapi)
add_subdirectory(ltrlogapi)
add_subdirectory(ltr010api)
add_subdirectory(ltr030api)
add_subdirectory(ltr032api)
add_subdirectory(ltr021api)
add_subdirectory(ltrbootapi)
add_subdirectory(ltravrapi)


#API модулей
if(NOT ${CMAKE_SYSTEM_NAME} STREQUAL "QNX4")
add_subdirectory(ltr114api)
add_subdirectory(ltr212api)
endif()
add_subdirectory(ltr11api)
add_subdirectory(ltr22api)
add_subdirectory(ltr24api)
add_subdirectory(ltr25api)
add_subdirectory(ltr27api)
add_subdirectory(ltr34api)
add_subdirectory(ltr35api)
add_subdirectory(ltr41api)
add_subdirectory(ltr42api)
add_subdirectory(ltr43api)
add_subdirectory(ltr51api)
add_subdirectory(ltr210api)
if(LTRAPI_BUILD_DEVELOP_MODULES)
    add_subdirectory(ltr216api)
endif(LTRAPI_BUILD_DEVELOP_MODULES)

if(LTRAPI_BUILD_FABRIC_MODULES)
    # если включена опция то добавляем сборку API для производственных
    # модулей, которые используются только для наладки, а не пользователями
    add_subdirectory(ltrfapi)
endif(LTRAPI_BUILD_FABRIC_MODULES)

if(WIN32)
    add_subdirectory(ltrModulesNet)
endif(WIN32)


if(LTRAPI_BUILD_BORLAND_LIBS)
    #цель для построения всех .lib фалов Borland C++
    add_custom_target(borland_libs ALL
                      DEPENDS ${LTRAPI_BORLAND_LIBS})
endif(LTRAPI_BUILD_BORLAND_LIBS)

if(LTRAPI_BUILD_MINGW_LIBS)
    #цель для построения всех .a файлов для mingw
    add_custom_target(mingw_libs ALL
                      DEPENDS ${LTRAPI_MINGW_LIBS})
endif(LTRAPI_BUILD_MINGW_LIBS)

if(LTR_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif(LTR_BUILD_EXAMPLES)

#цели для сборки пакетов
if(UNIX AND LTR_CMAKE_PACKAGES)
    set(PACKAGE_NAME     ltrapi)
    set(PACKAGE_VERSION  ${LTRAPI_VERSION})
    set(PACKAGE_FREEBSD_CATEGORY  science)
    include(${LTR_CMAKE_PACKAGES})
endif(UNIX AND LTR_CMAKE_PACKAGES)

if(WIN32 AND LTR_BUILD_WIN_INSTALLERS)
    set(LTR_CONVERTED_SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/src)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/x64)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/x86)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src)

    string(REGEX REPLACE "/" "\\\\" ICONV ${ICONV})
    string(REGEX REPLACE "/" "\\\\" LTR_CONVERTED_SOURCE_DIR ${LTR_CONVERTED_SOURCE_DIR})
    set(LTR_ORIG_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
    string(REGEX REPLACE "/" "\\\\" LTR_ORIG_SOURCE_DIR ${LTR_ORIG_SOURCE_DIR})

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/win_install/conv_src_cp1251.bat.in
                   ${CMAKE_CURRENT_BINARY_DIR}/conv_src_cp1251.bat @ONLY)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/win_install/make64.bat.in
               ${CMAKE_CURRENT_BINARY_DIR}/x64/make.bat @ONLY)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/win_install/make32.bat.in
               ${CMAKE_CURRENT_BINARY_DIR}/x86/make.bat @ONLY)
    add_custom_target(convert_src
        COMMAND cmd /c conv_src_cp1251.bat
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    add_custom_target(api64
        COMMAND cmd /c make.bat
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/x64
        DEPENDS convert_src)

    #x86 версию собираем 2008 студией (Express) для совместимости с Win2000
    #set(VS2008_SETENV "${VS2008_DIR}/vcvarsall.bat")
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/x86)
    add_custom_target(api32
        COMMAND cmd /c make.bat
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/x86
        DEPENDS convert_src
        )

    set(INSTALLER_NAME ${LTR_CRATE_NAME_LOWER}dll_${LTRAPI_VERSION}.exe)

    set(PASCAL_OLD_PATH ${CMAKE_CURRENT_SOURCE_DIR}/win_install/pascal_old)

    #конфигурируем NSIS-файл
    configure_file(win_install/ltrapi.nsi.in
                   ${PROJECT_BINARY_DIR}/ltrapi.nsi @ONLY)

    #собираем сам установщик
    add_custom_target(ltrapi-installer
        #по nsi файлу создаем установщик
        COMMAND ${NSIS_EXEC} ltrapi.nsi
        DEPENDS api32
        DEPENDS api64
        DEPENDS ltrModulesNet
        DEPENDS ${PROJECT_BINARY_DIR}/ltrapi.nsi
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )

    if(NOT WIN_INSTALLER_NOSIGN)
        #подписываем установщик при неободимости
        add_custom_command(TARGET ltrapi-installer POST_BUILD
            COMMAND "${SIGNTOOL}" sign /v /ac "${SIGN_CERT}" /n "${SIGN_COMPANY_NAME}" /t ${CERT_TIMESTAMP_URL} ${INSTALLER_NAME}
            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
        )
    endif(NOT WIN_INSTALLER_NOSIGN)
endif(WIN32 AND LTR_BUILD_WIN_INSTALLERS)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

add_subdirectory(c)

=== ltr010api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME          LTR010)
set(LTRAPI_MODULE_NO_STD_FUNC   ON)
set(LTRAPI_MODULE_DESCR_ENG     "Low-level library for LTR-U-8/16 crates")
set(LTRAPI_MODULE_DESCR_RUS     "Библиотека низкоуровневых функций для крейтов LTR-U-8/16")

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr021api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME          LTR021)
set(LTRAPI_MODULE_NO_STD_FUNC   ON)
set(LTRAPI_MODULE_DESCR_ENG     "Library for configure LTR-U-1 crates")
set(LTRAPI_MODULE_DESCR_RUS     "Библиотека функций для настройки крейтов LTR-U-1")


include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr030api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME      LTR030)
set(LTRAPI_MODULE_USE_TIMER ON)
set(LTRAPI_MODULE_USE_CRC   ON)
set(LTRAPI_MODULE_DESCR_ENG     "Library for configure and update firmware for LTR-EU crates")
set(LTRAPI_MODULE_DESCR_RUS     "Библиотека для конфигурации и обновления прошивок крейтов LTR-EU")


include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr032api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME          LTR032)
set(LTRAPI_MODULE_USE_TIMER     ON)
set(LTRAPI_MODULE_DESCR_ENG     "Library for control LTR-E-7/15 crates")
set(LTRAPI_MODULE_DESCR_RUS     "Библиотека для управления крейтами LTR-E-7/15")


include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr114api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME      LTR114)
set(LTRAPI_MODULE_USE_TIMER ON)
set(LTRAPI_MODULE_USE_CRC   ON)

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr11api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME      LTR11)
set(LTRAPI_MODULE_USE_TIMER ON)
set(LTRAPI_MODULE_USE_CRC   ON)

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr210api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME              LTR210)
set(LTRAPI_MODULE_USE_TIMER         ON)
set(LTRAPI_MODULE_USE_MATH          ON)
set(LTRAPI_MODULE_USE_CRC           ON)
set(LTRAPI_MODULE_USE_CYCLONE       ON)
set(LTRAPI_MODULE_USE_FLASH_AT25DF  ON)
set(LTRAPI_MODULE_USE_FLASH_AT25SF  ON)
set(LTRAPI_MODULE_USE_DOXYGEN_DOC   ON)

#для включения прошивки в библиотеку под Windows
if(WIN32)
    set(LTRAPI_MODULE_RC_STRINGS        "LTR210_FPGA   RCDATA  ${CMAKE_CURRENT_SOURCE_DIR}/ltr210_fpga.rbf")
    set(LTRAPI_MODULE_BUILD_DEPENDENCIES ${CMAKE_CURRENT_SOURCE_DIR}/ltr210_fpga.rbf)
endif(WIN32)
set(LTRAPI_MODULE_DOC_INPUT_FILES   doc/gen_descr.md)

set(LTRAPI_MODULE_INSTALL_DATA_FILES  "ltr210_fpga.rbf")

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr212api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME      LTR212)
set(LTRAPI_MODULE_USE_TIMER ON)
set(LTRAPI_MODULE_USE_CRC   ON)


#для включения прошивки в библиотеку под Windows
if(WIN32)
    set(LTRAPI_MODULE_RC_STRINGS        "LTR212_BIO   RCDATA  ${CMAKE_CURRENT_SOURCE_DIR}/ltr212.bio")
    set(LTRAPI_MODULE_BUILD_DEPENDENCIES ${CMAKE_CURRENT_SOURCE_DIR}/ltr212.bio)
endif(WIN32)
set(LTRAPI_MODULE_INSTALL_DATA_FILES "ltr212.bio")

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr216api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME                  LTR216)
set(LTRAPI_MODULE_USE_TIMER             ON)
set(LTRAPI_MODULE_USE_CRC               ON)
set(LTRAPI_MODULE_USE_FLASH_SST25       ON)

set(LTRAPI_MODULE_HEADERS               "ad7176.h")

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr22api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LTRAPI_MODULE_NAME      LTR22)
set(LTRAPI_MODULE_USE_TIMER ON)
set(LTRAPI_MODULE_USE_CRC   OFF)

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== debian/changelog ===
ltrapi (1.31.3)  stable; urgency=low

  * Initial Release.

 -- Borisov Alexey <borisov@lcard.ru>  Sat, 31 Mar 2012 12:25:54 +0400

=== debian/control ===
Source: ltrapi
Priority: optional
Maintainer: Borisov Alexey <borisov@lcard.ru>
Build-Depends: debhelper (>= 8.0.0), cmake
Standards-Version: 3.9.3
Section: libs
Homepage: "http://www.lcard.ru"

Package: libltrapi1-dev
Section: libdevel
Architecture: any
Depends: libltrapi1 (= ${binary:Version}), ${misc:Depends},
  libltr010api1 (= ${binary:Version}),
  libltr021api1 (= ${binary:Version}),
  libltr030api1 (= ${binary:Version}),
  libltr032api1 (= ${binary:Version}),
  libltrlogapi1 (= ${binary:Version}),
  libltravrapi1 (= ${binary:Version}),
  libltrbootapi1 (= ${binary:Version}),
  libltr11api1 (= ${binary:Version}),
  libltr114api1 (= ${binary:Version}), 
  libltr22api1 (= ${binary:Version}),
  libltr24api1 (= ${binary:Version}),
  libltr25api1 (= ${binary:Version}),
  libltr27api1 (= ${binary:Version}),
  libltr34api1 (= ${binary:Version}),
  libltr35api1 (= ${binary:Version}),
  libltr41api1 (= ${binary:Version}),
  libltr42api1 (= ${binary:Version}),
  libltr43api1 (= ${binary:Version}),
  libltr51api1 (= ${binary:Version}),
  libltr210api1 (= ${binary:Version}),
  libltr212api1 (= ${binary:Version})
Description:Libraries for control 'L Card' LTR-Crates (development files)
 Libraries that allow you connect to ltrd daemon and control L-Card LTR-Crates 
 and LTR-Modules.
 .
 This package contains the development headers for the libraries found in 
 packages libltrapi1, libltr11api1, etc.
 .
 You need these files if you writing your own software. Non-developers likely 
 have little use for this package.

Package: libltrapi1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control 'L Card' LTR-Crates and LTR-modules (runtime libraries)
 This package contains the library which allows you to control 'L Card' LTR-Crates and LTR-modules. 
 API to control certain LTR-module you can find in packages with names like libltrXXXapi1,
 where XXX - module number (ltr114api1, ltr34api1, etc).
 .
 This package contains the shared object files.
 
Package: libltr010api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR-U-8/16 Crates (runtime libraries)
 This package contains the library which allows you to control L-Card LTR-Crates 
 with LTR010 crate-controller (LTR-U-8/16). 
 This is low level API used by others libraries.
 .
 This package contains the shared object files.

Package: libltr021api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR-U-1-4 Crates (runtime libraries)
 This package contains the library which allows you to configure L-Card LTR-Crates
 with LTR021 crate-controller (LTR-U-1-4).
 .
 This package contains the shared object files.
 
Package: libltr030api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR-EU Crates (runtime libraries)
 This package contains the library which allows you to configure and
 update firmware for  L-Card LTR-Crates  with LTR030/LTR031 
 crate-controller (LTR-EU-8/16, LTR-EU-2). 
 This is low level API used by others libraries.
 .
 This package contains the shared object files.

Package: libltr032api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR-E Crates (runtime libraries)
 This package contains the library which allows you to
 control L-Card LTR-Crates  with LTR032 
 crate-controller (LTR-E-7/15).
 .
 This package contains the shared object files.
 
Package: libltrlogapi1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for getting ltrd log (runtime libraries)
 This package contains the library which allows you to 
 get ltrd log in real-time.
 .
 This package contains the shared object files.
 
Package: libltravrapi1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for update AVR firmware for LTR-modules (runtime libraries)
 This package contains the library with API wich allows you update AVR-firmware 
 for LTR-modules with AVR microcontroller (LTR11, LTR114, LTR27, LTR41, LTR42, LTR43, LTR51).
 .
 This package contains the shared object files.
 
 
Package: libltrbootapi1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for update firmware for LTR-U-8/16 crates (runtime libraries)
 This package contains the library which provide functions that allow you update FPGA-firmware for 
 'L Card' LTR-U 8/16 crates.
 .
 This package contains the shared object files.

Package: libltr11api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR11 module (runtime libraries)
 This package contains the library which allows you control LTR11 module.
 .
 This package contains the shared object files.

Package: libltr114api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR114 module (runtime libraries)
 This package contains the library which allows you control LTR114 module.
 .
 This package contains the shared object files.

Package: libltr22api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR22 module (runtime libraries)
 This package contains the library which allows you control LTR22 module.
 .
 This package contains the shared object files.
 
Package: libltr24api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR24 module (runtime libraries)
 This package contains the library which allows you control LTR24 module.
 .
 This package contains the shared object files.

Package: libltr25api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR25 module (runtime libraries)
 This package contains the library which allows you control LTR25 module.
 .
 This package contains the shared object files.
 
Package: libltr27api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR27 module (runtime libraries)
 This package contains the library which allows you control LTR27 module.
 .
 This package contains the shared object files.

Package: libltr34api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR34 module (runtime libraries)
 This package contains the library which allows you control LTR34 module.
 .
 This package contains the shared object files.
 
Package: libltr35api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR35 module (runtime libraries)
 This package contains the library which allows you control LTR35 module.
 .
 This package contains the shared object files.

Package: libltr41api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR41 module (runtime libraries)
 This package contains the library which allows you control LTR41 module.
 .
 This package contains the shared object files.

Package: libltr42api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR42 module (runtime libraries)
 This package contains the library which allows you control LTR42 module.
 .
 This package contains the shared object files.

Package: libltr43api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR43 module (runtime libraries)
 This package contains the library which allows you control LTR43 module.
 .
 This package contains the shared object files.

Package: libltr51api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR51 module (runtime libraries)
 This package contains the library which allows you control LTR51 module.
 .
 This package contains the shared object files.
 
Package: libltr210api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR210 module (runtime libraries)
 This package contains the library which allows you control LTR210 module.
 .
 This package contains the shared object files.
 
Package: libltr212api1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Library for control LTR212 module (runtime libraries)
 This package contains the library which allows you control LTR212 module.
 .
 This package contains the shared object files.

## ltrapi 1.32.39

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 
 if(NOT LTR_SDK_SUFFIX)
@@ -8,14 +8,15 @@
 project(ltrapi C)
 
 set(LTRAPI_VER_MAJOR 1)
-set(LTRAPI_VER_MINOR 31)
-set(LTRAPI_VER_PATCH 3)
+set(LTRAPI_VER_MINOR 32)
+set(LTRAPI_VER_PATCH 39)
 set(LTRAPI_VERSION   ${LTRAPI_VER_MAJOR}.${LTRAPI_VER_MINOR}.${LTRAPI_VER_PATCH})
 
 option(LTR_FORCE_RESET_WHEN_IN_USE "Send STOP-RESET-STOP if module in use for compatibility with old behavior" OFF)
 option(LTR_BUILD_EXAMPLES  "Build ltrapi C examples" OFF)
 option(LTR_DEBUG_PRINT "Debug console printf" OFF)
 option(LTR_ERROR_PRINT "Debug console printf" OFF)
+option(LTRAPI_USE_KD_STORESLOTS  "Enable slot configuration store in crate support" OFF)
 # linux: с версии 1.31.2 по-умолчанию приход сигнала на Linux не прерывает работу функций
 # Recv() и Send(), т.к. в некоторых случаях сигналы могут использоваться переодически
 # и нарушать работу функций (например в Mono при нескольких потоках).
@@ -24,7 +25,11 @@
 option(LTRAPI_BUILD_STATIC "Build static libraries rather dynamic" OFF)
 option(LTRAPI_BUILD_FABRIC_MODULES "Build library for fabric modules" OFF)
 option(LTRAPI_BUILD_DEVELOP_MODULES "Build library for currently development modules" OFF)
-
+option(LTRAPI_BUILD_MATH_EXAMPLES "Build examples required math & fft libraries" OFF)
+
+if(WIN32)
+    option(LTRAPI_USE_WSA_SOCKS "Use WSA Sockets on Windows" OFF)
+endif(WIN32)
 
 if(LTR_PRODUCT_NAMES_FILE)
     include(${LTR_PRODUCT_NAMES_FILE})
@@ -39,6 +44,7 @@
     option(LTRAPI_PREPARE_HEADERS "prepare pucblic ltrapi headers in build directory" OFF)
 endif(NOT LTRAPI_PREPARE_HEADERS)
 
+add_definitions(-DLTRAPI_DISABLE_COMPAT_DEFS)
 if(LTR_FORCE_RESET_WHEN_IN_USE)
     add_definitions(-DLTR_FORCE_RESET_WHEN_IN_USE)
 endif(LTR_FORCE_RESET_WHEN_IN_USE)
@@ -54,6 +60,10 @@
 if(LTR_ERROR_PRINT)
     add_definitions(-DLTR_ERROR_PRINT)
 endif(LTR_ERROR_PRINT)
+
+if(NOT ${CMAKE_VERSION}  VERSION_LESS "3.0.0") 
+    string(TIMESTAMP CURRENT_YEAR "%Y")
+endif()    
 
 # для QNX4 используются всегда статические библиотеки
 if(${CMAKE_SYSTEM_NAME} STREQUAL "QNX4")
@@ -215,6 +225,7 @@
 add_subdirectory(ltr212api)
 endif()
 add_subdirectory(ltr11api)
+add_subdirectory(ltr12api)
 add_subdirectory(ltr22api)
 add_subdirectory(ltr24api)
 add_subdirectory(ltr25api)
@@ -226,12 +237,12 @@
 add_subdirectory(ltr43api)
 add_subdirectory(ltr51api)
 add_subdirectory(ltr210api)
-if(LTRAPI_BUILD_DEVELOP_MODULES)
-    add_subdirectory(ltr216api)
-endif(LTRAPI_BUILD_DEVELOP_MODULES)
+add_subdirectory(ltr216api)
+add_subdirectory(ltedsapi)
+add_subdirectory(lpw25api)
 
 if(LTRAPI_BUILD_FABRIC_MODULES)
-    # если включена опция то добавляем сборку API для производственных
+    # если включена опция, то добавляем сборку API для производственных
     # модулей, которые используются только для наладки, а не пользователями
     add_subdirectory(ltrfapi)
 endif(LTRAPI_BUILD_FABRIC_MODULES)
@@ -265,13 +276,19 @@
     include(${LTR_CMAKE_PACKAGES})
 endif(UNIX AND LTR_CMAKE_PACKAGES)
 
+if(WIN32)
+    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/nuget/ltrapi.nuspec.in
+                  ${CMAKE_CURRENT_BINARY_DIR}/ltrapi.nuspec)
+endif(WIN32)
+
+
 if(WIN32 AND LTR_BUILD_WIN_INSTALLERS)
     set(LTR_CONVERTED_SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/src)
     file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/x64)
     file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/x86)
     file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src)
 
-    string(REGEX REPLACE "/" "\\\\" ICONV ${ICONV})
+    string(REGEX REPLACE "/" "\\\\" ICONV_EXEC ${ICONV_EXEC})
     string(REGEX REPLACE "/" "\\\\" LTR_CONVERTED_SOURCE_DIR ${LTR_CONVERTED_SOURCE_DIR})
     set(LTR_ORIG_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
     string(REGEX REPLACE "/" "\\\\" LTR_ORIG_SOURCE_DIR ${LTR_ORIG_SOURCE_DIR})
@@ -320,12 +337,3 @@
     )
 
     if(NOT WIN_INSTALLER_NOSIGN)
-        #подписываем установщик при неободимости
-        add_custom_command(TARGET ltrapi-installer POST_BUILD
-            COMMAND "${SIGNTOOL}" sign /v /ac "${SIGN_CERT}" /n "${SIGN_COMPANY_NAME}" /t ${CERT_TIMESTAMP_URL} ${INSTALLER_NAME}
-            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
-        )
-    endif(NOT WIN_INSTALLER_NOSIGN)
-endif(WIN32 AND LTR_BUILD_WIN_INSTALLERS)
-
-

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

add_subdirectory(c)

=== lpw25api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

set(LTRAPI_MODULE_NAME                  LPW25)
set(LTRAPI_MODULE_NO_STD_FUNC           ON)
set(LTRAPI_MODULE_NO_LTRAPI             ON)
set(LTRAPI_MODULE_USE_PHASE_FILTER      ON)
set(LTRAPI_MODULE_USE_MATH              ON)
set(LTRAPI_MODULE_USE_DOXYGEN_DOC       ON)
set(LTRAPI_MODULE_REQ_MODULES           ltedsapi)

set(LTRAPI_MODULE_DOC_ABOUT_FILE  doc/about.md.in)
set(LTRAPI_MODULE_DOC_INPUT_FILES doc/gen_descr.md)

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltedsapi/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

set(LTRAPI_MODULE_PROJECT               ltedsapi)
set(LTRAPI_MODULE_NO_STD_FUNC           ON)
set(LTRAPI_MODULE_NO_LTRAPI             ON)
set(LTRAPI_MODULE_USE_MATH              ON)
set(LTRAPI_MODULE_USE_DOXYGEN_DOC       ON)
set(LTRAPI_MODULE_SOURCES               ltedsapi_lcard.c ltedsapi_stdtmpl.c)
set(LTRAPI_MODULE_SETUP_HEADERS         ltedsapi_base.h ltedsapi_lcard.h ltedsapi_stdtmpl.h)
set(LTRAPI_MODULE_REQ_MODULES           ltrapi)

set(LTRAPI_MODULE_DOC_ABOUT_FILE  doc/about.md.in)
set(LTRAPI_MODULE_DOC_INPUT_FILES doc/gen_descr.md ${LTRAPI_MODULE_SETUP_HEADERS})

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr010api/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 set(LTRAPI_MODULE_NAME          LTR010)
 set(LTRAPI_MODULE_NO_STD_FUNC   ON)

=== ltr021api/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 set(LTRAPI_MODULE_NAME          LTR021)
 set(LTRAPI_MODULE_NO_STD_FUNC   ON)

=== ltr030api/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 set(LTRAPI_MODULE_NAME      LTR030)
 set(LTRAPI_MODULE_USE_TIMER ON)

=== ltr032api/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 set(LTRAPI_MODULE_NAME          LTR032)
 set(LTRAPI_MODULE_USE_TIMER     ON)

=== ltr114api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

set(LTRAPI_MODULE_NAME      LTR114)
set(LTRAPI_MODULE_USE_TIMER ON)
set(LTRAPI_MODULE_USE_CRC   ON)
set(LTRAPI_MODULE_USE_MATH  ON)
#используем вручную созданный def для mingw, так как gendef неправильно определяет
#количество параметров для LTR114_CreateLChannel
set(LTRAPI_MODULE_MINGW_MANUAL_DEF ${CMAKE_CURRENT_SOURCE_DIR}/ltr114api_mingw_custom.def)

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr11api/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 set(LTRAPI_MODULE_NAME      LTR11)
 set(LTRAPI_MODULE_USE_TIMER ON)

=== ltr12api/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

set(LTRAPI_MODULE_NAME      LTR12)
set(LTRAPI_MODULE_USE_TIMER             ON)
set(LTRAPI_MODULE_USE_CRC               ON)
set(LTRAPI_MODULE_USE_DOXYGEN_DOC       ON)

set(LTRAPI_MODULE_DOC_INPUT_FILES doc/gen_descr.md)

include(${LTRAPI_MODULE_CMAKE_TEMPLATE})

=== ltr210api/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 set(LTRAPI_MODULE_NAME              LTR210)
 set(LTRAPI_MODULE_USE_TIMER         ON)
@@ -6,7 +6,7 @@
 set(LTRAPI_MODULE_USE_CRC           ON)
 set(LTRAPI_MODULE_USE_CYCLONE       ON)
 set(LTRAPI_MODULE_USE_FLASH_AT25DF  ON)
-set(LTRAPI_MODULE_USE_FLASH_AT25SF  ON)
+set(LTRAPI_MODULE_USE_FLASH_X25     ON)
 set(LTRAPI_MODULE_USE_DOXYGEN_DOC   ON)
 
 #для включения прошивки в библиотеку под Windows

=== debian/changelog ===
ltrapi (1.32.39)  stable; urgency=low

  * Initial Release.

 -- Borisov Alexey <borisov@lcard.ru>  Sat, 31 Mar 2012 12:25:54 +0400

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
   libltravrapi1 (= ${binary:Version}),
   libltrbootapi1 (= ${binary:Version}),
   libltr11api1 (= ${binary:Version}),
+  libltr12api1 (= ${binary:Version}),
   libltr114api1 (= ${binary:Version}), 
   libltr22api1 (= ${binary:Version}),
   libltr24api1 (= ${binary:Version}),
@@ -30,7 +31,10 @@
   libltr43api1 (= ${binary:Version}),
   libltr51api1 (= ${binary:Version}),
   libltr210api1 (= ${binary:Version}),
-  libltr212api1 (= ${binary:Version})
+  libltr212api1 (= ${binary:Version}),
+  libltr216api1 (= ${binary:Version}),
+  libltedsapi1 (= ${binary:Version}),
+  liblpw25api1 (= ${binary:Version})
 Description:Libraries for control 'L Card' LTR-Crates (development files)
  Libraries that allow you connect to ltrd daemon and control L-Card LTR-Crates 
  and LTR-Modules.
@@ -112,7 +116,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description:Library for update AVR firmware for LTR-modules (runtime libraries)
  This package contains the library with API wich allows you update AVR-firmware 
- for LTR-modules with AVR microcontroller (LTR11, LTR114, LTR27, LTR41, LTR42, LTR43, LTR51).
+ for LTR-modules with AVR microcontroller (LTR11, LTR12, LTR114, LTR27, LTR41, LTR42, LTR43, LTR51).
  .
  This package contains the shared object files.
  
@@ -136,6 +140,15 @@
  .
  This package contains the shared object files.
 
+Package: libltr12api1
+Section: libs
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description:Library for control LTR12 module (runtime libraries)
+ This package contains the library which allows you control LTR12 module.
+ .
+ This package contains the shared object files.
+
 Package: libltr114api1
 Section: libs
 Architecture: any
@@ -253,5 +266,29 @@
  .
  This package contains the shared object files.
 
-
-
+Package: libltr216api1
+Section: libs
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description:Library for control LTR216 module (runtime libraries)
+ This package contains the library which allows you control LTR216 module.
+ .
+ This package contains the shared object files.
+
+Package: libltedsapi1
+Section: libs
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description:Library for decode and encode TEDS data (runtime libraries)
+ This package contains the library which allows you decode and encode TEDS data.
+ .
+ This package contains the shared object files.
+
+Package: liblpw25api1
+Section: libs
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description:Library for process LPW25 data (runtime libraries)
+ This package contains the library which allows you process data from LPW25 trasducer output.
+ .
+ This package contains the shared object files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --builddirectory=builds/deb_package

override_dh_auto_configure: 
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release
